<?php
/**
 * Ethna_Plugin_Generator_ScaffoldActions.php
 * 
 * @author BoBpp < bobpp@users.sourceforge.jp >
 * @package projBop.Ethna.Scaffold
 */

/**
 * ScaffoldActions Generator Plugin
 * 
 * @access public
 * @author BoBpp < bobpp@users.sourceforge.jp >
 * @package projBop.Ethna.Scaffold
 */
class Ethna_Plugin_Generator_ScaffoldActions extends Ethna_Plugin_Generator
{
	/**
	 * ScaffoldActions 
	 * 
	 * @access public
	 * @param $baseAction string ١Υ̾
	 * @param $model string ǥ̾
	 * @param $modelDefine array ǥ
	 * @param $formDef array ե
	 */
	function &generate($baseAction, $model, $modelDefine, $idDefine, $formDef)
	{
		$table_id = preg_replace('/_(.)/e', "strtoupper('\$1')", ucfirst($model));
        $columnName_path = ucfirst($this->ctl->getAppId()) . '_' . $table_id . '_ColumnName.php';
				
		// Project Macro
		$projectMacro = array();
		$projectMacro['model'] = $model;
        $projectMacro['modelName'] = $table_id;
        $projectMacro['modelUName'] = strtoupper($table_id);
        $projectMacro['modelPK'] = $idDefine;
        $projectMacro['project_id'] = $this->ctl->getAppId();
        $projectMacro['column_name_file'] = $columnName_path;
        
        // ActionForm
        $form = $this->_getActionFormDefine($formDef);
		
		// Action
		$actions = array(
			"base" => array(
				'view_name' => $this->_getFullAction($baseAction, 'list'),
			),
			"index" => array(
				'view_name' => $this->_getFullAction($baseAction, 'list'),
			),
			"create" => array(
				'view_name' => $this->_getFullAction($baseAction, 'form_create'),
			),
			"create_do" => array(
				'view_error_name' => $this->_getFullAction($baseAction, 'form_create'),
				'view_name' => $this->_getFullAction($baseAction, 'list'),
				'form_define' => $form,
			),
			"update" => array(
				'view_error_name' => $this->_getFullAction($baseAction, 'list'),
				'view_name' => $this->_getFullAction($baseAction, 'form_update'),
			),
			"update_do" => array(
				'view_error_name' => $this->_getFullAction($baseAction, 'form_update'),
				'view_name' => $this->_getFullAction($baseAction, 'list'),
				'form_define' => $form,
			),
			"read" => array(
				'view_error_name' => $this->_getFullAction($baseAction, 'list'),
				'view_name' => $this->_getFullAction($baseAction, 'read'), 
			),
			"delete" => array(
				'view_error_name' => $this->_getFullAction($baseAction, 'list'),
				'view_name' => $this->_getFullAction($baseAction, 'delete'),
			),
			"delete_do" => array(
				'view_error_name' => $this->_getFullAction($baseAction, 'delete'),
				'view_name' => $this->_getFullAction($baseAction, 'list'),
			),
		);
		foreach ($actions as $action => $value) {
			if ($action != "base") {
				$action_name = $this->_getFullAction($baseAction, $action);
			} else {
				$action_name = $baseAction;
			}
			
			$action_dir = $this->ctl->getActiondir(GATEWAY_WWW);
	        $action_class = $this->ctl->getDefaultActionClass($action_name, GATEWAY_WWW);
	        $action_form = $this->ctl->getDefaultFormClass($action_name, GATEWAY_WWW);
	        $action_path = $this->ctl->getDefaultActionPath($action_name);
	        
	        $macro = $value;
	        $macro['action_name'] = $action_name;
		    $macro['action_class'] = $action_class;
		    $macro['action_form'] = $action_form;
		    $macro['action_path'] = $action_path;
	
	        $user_macro = $this->_getUserMacro();
	        $macro = array_merge($projectMacro, $macro, $user_macro);
	
	        Ethna_Util::mkdir(dirname("$action_dir$action_path"), 0755);
	
	        $skelton = "skel.scaffold-action-" . $action . ".php";
	
	        if (file_exists("$action_dir$action_path")) {
	            printf("file [%s] already exists -> skip\n", "$action_dir$action_path");
	        } else if ($this->_generateFile($skelton, "$action_dir$action_path", $macro) == false) {
	            printf("[warning] file creation failed [%s]\n", "$action_dir$action_path");
	        } else {
	            printf("action script(s) successfully created [%s]\n", "$action_dir$action_path");
	        }
		}
		$true = true;
        return $true;
	}
	
	/**
	 * ١ + ֤̾
	 * 
	 * @access private
	 * @param $base string ١̾
	 * @param $action string ̾
	 * @return string ̾
	 */
	function _getFullAction($base, $action)
	{
		return $base . "_" . $action;
	}
	
	/**
	 * եꤹ
	 * 
	 * @access private
	 * @param array $formDef ե
	 * @return string ActionForm
	 */
	function _getActionFormDefine($formDef)
	{
		// FormDefine
		$form = "";
		foreach ($formDef as $name => $value) {
			$form .= "		'{$name}' => array(\n";
			foreach ($value as $k => $v) {
				$form .= "			'{$k}' => {$v},\n";
			}
			$form .= "		),\n";
		}
		
		return $form;
	}
}
?>