<?php
/**
 * Ethna_Plugin_Generator_ScaffoldAppObject.php
 * 
 * @author BoBpp < bobpp@users.sourceforge.jp >
 * @package projBop.Ethna.Scaffold
 */

/**
 * ScaffoldAppObject Generator Plugin
 * 
 * @access public
 * @author BoBpp < bobpp@users.sourceforge.jp >
 * @package projBop.Ethna.Scaffold
 */
class Ethna_Plugin_Generator_ScaffoldAppObject extends Ethna_Plugin_Generator
{
	/**
	 * ScaffoldAppObject 
	 * 
	 * @access public
	 * @param $table_name string ơ֥̾
	 */
	function &generate($table_name)
	{
        $table_id = preg_replace('/_(.)/e', "strtoupper('\$1')", ucfirst($table_name));

        $app_dir = $this->ctl->getDirectory('app');
        $app_path = ucfirst($this->ctl->getAppId()) . '_' . $table_id .'.php';
        $columnName_path = ucfirst($this->ctl->getAppId()) . '_' . $table_id . '_ColumnName.php';
        $baseClass_path = ucfirst($this->ctl->getAppId()) . '_AppBase_AppObject.php';

        $macro = array();
        $macro['model'] = $table_name;
        $macro['modelName'] = $table_id;
        $macro['modelUName'] = strtoupper($table_id);
        $macro['project_id'] = $this->ctl->getAppId();
        $macro['app_path'] = $app_path;
        $macro['app_object'] = ucfirst($this->ctl->getAppId()) . '_' . $table_id;
        $macro['column_name_file'] = $columnName_path;
        $macro['base_class_file'] = $baseClass_path;

        $user_macro = $this->_getUserMacro();
        $macro = array_merge($macro, $user_macro);

        $path = "$app_dir/$app_path";
        Ethna_Util::mkdir(dirname($path), 0755);
        if (file_exists($path)) {
            printf("file [%s] already exists -> skip\n", $path);
        } else if ($this->_generateFile("skel.scaffold-appobject.php", $path, $macro) == false) {
            printf("[warning] file creation failed [%s]\n", $path);
        } else {
            printf("app-object script(s) successfully created [%s]\n", $path);
        }
        $true = true;
        return $true;
	}
}
?>